package neuralnetworkbase

import (
	math "math"
	rand "math/rand"

	mat "gonum.org/v1/gonum/mat"
)

func generateRandomDense(rows, columns int) *mat.Dense {
	data := make([]float64, rows*columns)
	for i := range data {
		data[i] = rand.NormFloat64()
	}
	return mat.NewDense(rows, columns, data)
}

func applySigmoid(_, _ int, x float64) float64 {
	return sigmoid(x)
}

func applySigmoidPrime(_, _ int, x float64) float64 {
	return sigmoidPrime(x)
}

func sigmoid(x float64) float64 {
	return 1.0 / (1.0 + math.Exp(-x))
}

func sigmoidPrime(x float64) float64 {
	return sigmoid(x) * (1 - sigmoid(x))
}
